package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLContext_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLContext extends JNIObject  {
	
	/* @generated */
	protected ISLContext(long ptr) {
		/*** PROTECTED REGION ID(ISLContext_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLContext build(long ptr) {
		return new ISLContext(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLContext_userCode) ENABLED START ***/
	private static ISLContext ctx;
	static {
		ctx = ISLContext.alloc();
	}
	public final static ISLContext getInstance() {
		return ctx;
	}
	
	@Override
	protected void finalize() {
		
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_ctx_alloc 
	 * 
	 * @generated
	**/
	 private static ISLContext alloc() { 
		/*** PROTECTED REGION ID(static_isl_ctx_alloc) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_ctx_alloc());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * record_stdout_start 
	 * 
	 * @generated
	**/
	 public static void recordStdoutStart() { 
		/*** PROTECTED REGION ID(static_record_stdout_start) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters();
			try {
				ISLNative.record_stdout_start();
			} finally {
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * record_stdout_end 
	 * 
	 * @generated
	**/
	 public static String recordStdoutEnd() { 
		/*** PROTECTED REGION ID(static_record_stdout_end) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.record_stdout_end();
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * record_stderr_start 
	 * 
	 * @generated
	**/
	 public static void recordStderrStart() { 
		/*** PROTECTED REGION ID(static_record_stderr_start) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters();
			try {
				ISLNative.record_stderr_start();
			} finally {
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * record_stderr_end 
	 * 
	 * @generated
	**/
	 public static String recordStderrEnd() { 
		/*** PROTECTED REGION ID(static_record_stderr_end) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.record_stderr_end();
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_ctx_options 
	 * 
	 * @generated
	**/
	public ISLOptions islCtxOptions() {
		/*** PROTECTED REGION ID(isl_ctx_options) DISABLED START ***/
		ISLOptions res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLOptions.build(ISLNative.isl_ctx_options(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ctx_free 
	 * 
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_ctx_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters();
			try {
				ISLNative.isl_ctx_free(getNativePtr(this));
			} finally {
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLContext_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
